<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    index: {
      type: Number,
      required: true,
      default: 0,
    },
  },
  data() {
    return {
      isPlaying: false,
    };
  },
  mounted() {
    this.observeVideo();
  },
  methods: {
    observeVideo() {
      const options = {
        root: null,
        rootMargin: '0px',
        threshold: 0.9, // Play when 90% of the video is in view
      };

      const observer = new IntersectionObserver((entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            this.isPlaying = true;
            this.$refs.videoElement.play();
          } else {
            this.isPlaying = false;
            this.$refs.videoElement.pause();
          }
        });
      }, options);

      observer.observe(this.$refs.videoRef);
    },
  },
});
</script>

<template>
  <div class="video-features" :class="data.left === true ? 'left' : 'right'">
    <SlpRow>
      <SlpColumn :cols="6">
        <div class="eyebrow">
          <SlpIcon
            :name="data.icon"
            class="icon"
            variant="marketing"
            size="xl"
          />
          <SlpTypography variant="body2-bold" tag="span">
            {{ data.pill }}
          </SlpTypography>
        </div>
        <SlpTypography
          class="slp-pb-16 text-white"
          variant="heading3-bold"
          tag="h2"
        >
          {{ data.header }}
        </SlpTypography>
        <SlpTypography variant="body1" tag="p">
          {{ data.text }}
        </SlpTypography>
      </SlpColumn>
      <SlpColumn :cols="6">
        <div v-if="data.video" class="ai-features-card">
          <div
            ref="videoRef"
            class="ai-features-card__inner"
            :data-index="index"
          >
            <video
              ref="videoElement"
              class="video-looping"
              loop
              muted
              playsinline
              autoplay="isPlaying"
              :poster="data.video.thumbnail"
            >
              <source :src="data.video?.mp4_url" type="video/mp4" />
              <source :src="data.video?.webm_url" type="video/webm" />
            </video>
          </div>
        </div>
        <div v-else class="ai-features-card ai-features-card-image">
          <img :src="data.image" />
        </div>
      </SlpColumn>
    </SlpRow>
  </div>
</template>

<style lang="scss" scoped>
.video-features {
  color: $color-text-50;
  padding: 80px 0;
  .ai-features-card {
    max-width: 100%;
    border-radius: 8px 8px 120px 8px;

    @media (max-width: $breakpoint-md) {
      margin-top: $spacing-48;
      height: 200px;
    }
  }

  .video-looping {
    height: 100%;
  }

  .slp-row {
    align-items: center;
    @media (max-width: $breakpoint-md) {
      justify-content: center;
    }
  }

  .slp-col-md-6 {
    padding: 0 $spacing-24;
  }

  p {
    color: $color-surface-400;
  }

  &::v-deep strong {
    font-weight: 600;
    color: $color-text-50;
  }

  &.left {
    .slp-row {
      flex-direction: row-reverse;
    }
    .ai-features-card {
      max-width: 100%;
      border-radius: 8px 8px 8px 120px;
    }
  }

  .eyebrow {
    margin-bottom: 16px;
    position: relative;
    padding: 4px 12px;
    display: inline-flex;
    align-items: center;

    .slp-icon {
      width: 20px;
      height: 20px;
      margin-right: 5px;
      color: linear-gradient(
          89.09deg,
          #e1986d -1.12%,
          #7759c2 102.06%,
          #6e43d3 102.07%
        )
        border-box;
    }

    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      border-radius: 20px;
      border: 1.5px solid transparent;
      background: linear-gradient(
          89.09deg,
          #e1986d -1.12%,
          #7759c2 102.06%,
          #6e43d3 102.07%
        )
        border-box;
      -webkit-mask:
        linear-gradient(#fff 0, #fff 0) padding-box,
        linear-gradient(#fff 0, #fff 0);
      -webkit-mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      -webkit-mask-composite: xor;
      mask-composite: exclude;
    }
  }
}

.ai-features-card {
  border: 1px solid $color-surface-600;
  overflow: hidden;
  height: 350px;

  img {
    height: 100%;
  }

  &__inner {
    position: relative;
    height: 100%;

    img {
      width: 100%;
      cursor: pointer;
      display: block;
      transition: all 0.2s ease;
    }
  }
}

.ai-card-content {
  padding: 32px;
  background: linear-gradient(
    0.71deg,
    rgba(225, 152, 109, 0.1) 0.61%,
    rgba(110, 67, 211, 0.1) 99.4%
  );

  &::v-deep em {
    font-style: normal;
    color: $color-text-50;
  }
}

.ai-features-card-list {
  display: flex;
  flex-wrap: wrap;
  gap: 24px;

  &.chat {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: 1fr 1fr;
    justify-items: stretch;
    align-items: stretch;
  }

  @media screen and (max-width: 768px) {
    flex-direction: column;

    &.chat {
      grid-template-columns: 1fr;
    }
  }
}

.ai-features-card-item {
  border-radius: 8px;
  width: calc(50% - 12px);
  padding: 24px;
  background: $color-surface-700;

  &.chat {
    width: initial;
  }

  @media screen and (max-width: 768px) {
    width: 100%;
  }

  &--long {
    width: 100%;
  }
}

.text-heading {
  font-size: 32px;
  font-weight: 600;
  letter-spacing: -0.8px;
  line-height: 40px;
}

.text-subheading {
  font-size: 24px;
  font-weight: 600;
  letter-spacing: -0.6px;
  line-height: 32px;
}

.text-gray {
  color: #a2a1a6;
}

.text-white {
  color: $color-text-50;
}

/* copy pasted from featured-add-ons-card-tier.vue, but with some adjustments */
.addon-tier__pill-wrapper {
  top: -30px;
  position: relative;
  padding: 4px 12px;
  display: inline-block;

  &::before {
    content: '';
    position: absolute;
    inset: 0;
    border-radius: 20px;
    border: 1.5px solid transparent;
    background: linear-gradient(
        89.09deg,
        #e1986d -1.12%,
        #7759c2 102.06%,
        #6e43d3 102.07%
      )
      border-box;
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
  }
}

.addon-tier__pill {
  img {
    position: absolute;
    top: 8px;
  }

  span {
    padding-left: 20px;
    display: block;
    letter-spacing: 0.3px;
  }
}
</style>
